--[[ <HCExtension>
@name          Google Earth caching
@author        nadenj@mail.ru
@version       0.06
@description   Google Earth flatfiles caching
@rule          kh(mdb)?\.google\.com/(flatfile|dbRoot\.v\d+)\?
@event         RequestHeaderReceived/request
@event			URLToFileNameConverting/conv
</HCExtension> ]]

--[[*********************************************************************************
	:	1.	      (  
						    Lua-API,      )
					2.	/// no-cache   ,
						      .
*************************************************************************************]]

--     4- ,    
--(      ) 
 local function IntToChars(int)
   local ch = ''
   for j=1,4 do
     ch = ch .. string.char(int%256)
     int = math.floor(int/256)
   end
   return ch
 end
 
--  
 local function CharsToInt(chr)
   local int = 0
   for j=1,4 do
     int = int + string.byte(chr:sub(j,j))*256^(j-1)
   end
   return int
 end

-- local URLBase

local function OriginURL(cut_url)
	if cut_url:find('+', 1, true) then
		return re.replace(URLBase, '===', cut_url)
	end
	return re.replace(URLBase, '===.*', cut_url)
end

local function to_log(log_str)
	local ef = io.open(re.replace(hc.script_name, [[(.*\.).*]], [[\1log]]), 'ab')
	if ef then
		ef:write(os.date(), '    ', log_str, '\r\n')
		ef:close()
	end
end


-- **********                              **********
   
function request()

	-- if hc.url:find('geauth') then
	-- hc.put_msg('ops')
-- local f=io.open(hc.get_cache_file_name(hc.url), 'rb')
-- hc.answer_body = f:read('*a')
-- f:close()
		-- hc.answer_header = 'HTTP/1.1 200 OK\r\nContent-Type: application/octet-stream\r\nExpires: 0\r\n' ..
-- 'Cache-Control: no-cache,no-store\r\nSet-Cookie: PREF=ID=04c59454d2abb6b7:TM=1243710370:LM=1243710370:S=YdBzseUhw6Z4z3xu; ' ..
-- 'expires=Mon, 30-May-2011 19:06:10 GMT; path=/; domain=.google.com\r\nDate: Sat, 30 May 2009 19:06:10 GMT\r\nServer: btfe\r\n' ..
-- 'Content-Length: ' .. #hc.answer_body .. '\r\n\r\n'
		-- return
	-- end

	if not re.find(hc.url, [[kh(mdb)?\.google\.com/flatfile\?]]) then
		return		--    ,  
	end
	local URLTail = re.replace(hc.url, [[(^http://kh(mdb)?\.google\.com/flatfile\?(db=\w+&)?+)([^&]+)(.*)]], [[\4]])
	URLBase = re.replace(hc.url, nil, [[\1===\5]])
	--     ,    
	-- hc.put_to_log('+++++++++++++ ', URLTail, ' +++++++++++')
	if not URLTail:find('+', 1, true) then
		hc.action = 'dont_update'
		hc.monitor_string = (hc.cache_file_name ~= '') and '.GE'
		return
	end

	--       .     ,
	--   ,      
	hc.action = 'dont_save'
	GE = {}
	local i = 0                --     
	GE.not_in_cache_count = 0  --  ,   

	--      url     
	local not_cached_url = ''
	for file in URLTail:gmatch('[^+]+') do
		i = i+1
		GE[i] = {url=file}
		GE[i].fname, GE[i].in_cache = hc.get_cache_file_name(OriginURL(file))
		GE[i].in_cache = hc.read_from_cache_on and GE[i].in_cache	--     .,   ,     
		if GE[i].in_cache then
			while true do
				local cf = io.open(GE[i].fname, 'rb')
				if cf then
					GE[i].body = cf:read('*a')
					cf:close()
					hc.put_to_log('GE:     ', GE[i].fname)
					break
				else
					to_log('     ' .. GE[i].fname)
				end
			end
		else
			GE.not_in_cache_count = GE.not_in_cache_count + 1
			not_cached_url = not_cached_url .. '+' .. file
		end
	end

	--        ,     
	if GE.not_in_cache_count==0 then
		local header = '\1' .. string.char(i)  --     
		local body = ''                        --     
		local j = 1
		repeat
			local cf = io.open(GE[j].fname, 'rb')
			if cf then
				header = header .. IntToChars(2+4*i+#body)  --   j-   
				body = body .. cf:read('*a')     --   j-    
				cf:close()
				j = j + 1
			end
		until j>i
		hc.answer_body = header .. body
		hc.answer_header = 'HTTP/1.1 200 OK From Cache (HC)\r\nConnection: keep-alive\r\nServer: HandyCache\r\nContent-Length: ' ..
			#hc.answer_body .. '\r\n\r\n'
	--       hc.monitor_string = 'GE:      '
		hc.monitor_string = '.GE'

	else
		GE.body = ''
		GE.files_count = i
		--   URL,       
		not_cached_url = not_cached_url:gsub('+', '', 1)
		--        
		if not_cached_url:find('+', 1, true) then
			hc.request_header = re.replace(hc.request_header, [[.*?\?(db=\w+&)?+\K[^&\s]+]], not_cached_url)
		else
			hc.request_header = re.replace(hc.request_header, [[.*?\?(db=\w+&)?+\K\S+]], not_cached_url)
		end
		hc.call_me_for('BeforeAnswerBodySend', 'body')
	end
end

-- **********                        **********

function body()
	GE.body = GE.body .. hc.answer_body		--     
	local body = ''				--     
	if not hc.last_part then
		hc.answer_body = ''
		return
	end
	local i = GE.files_count
	local k = 0
	local header = '\1' .. string.char(i)  --     
	for j=1,i do
		header = header .. IntToChars(2+4*i+#body)  --   j-   
		if GE[j].in_cache then
			body = body .. GE[j].body
		else
			local bb
			if GE.not_in_cache_count==1 then
				bb = GE.body
			else
				k = k + 1
				bb = GE.body:sub(CharsToInt(GE.body:sub(k*4-1,k*4+2))+1,
					k<GE.not_in_cache_count and CharsToInt(GE.body:sub(3+k*4,3+(k+1)*4-1)) or -1)
			end
			hc.prepare_path(GE[j].fname)
			local ff = io.open(GE[j].fname, 'wb')
			if ff then
				ff:write(bb)   --  j-   
				ff:close()
				hc.put_to_log('GE:     ', GE[j].fname)
			--   RAM-       ,  j-    
				hc.update_url_info(OriginURL(GE[j].url))
			else
				to_log(' : ' .. GE[j].fname)
			end
			body = body .. bb
		end
	end
	hc.answer_body = header .. body
	hc.monitor_string = (GE.not_in_cache_count<i) and 'GE-   ' or '.GE'
end


function conv()
	if hc.url:find('+', 1, true) then
		return
	end
	local url = re.replace(hc.url, [[http://kh(mdb)?\.google\.com/(flatfile|dbRoot\.v\d+)\?]], '_GE_TILES_CACHE_/')
	url = re.replace(url, [[_/\K(?!db=)]], 'Earth/')
	url = re.replace(url, [[_/\Kdb=tm&]], 'History/')
	url = re.replace(url, [[_/\Kdb=sky&]], 'Sky/')
	url = re.replace(url, [[_/\Kdb=mars&]], 'Mars/') 
  url = re.replace(url, [[_/\Kdb=moon&]], 'Moon/')
	url = re.replace(url, [[/(?=f1-\d+-i)]], '/Image/')
	url = re.replace(url, [[/(?=f1-\d+-d\.(\d+))]], '/Textures/Layer_\\1/')
	url = re.replace(url, [[/(?=f1c-\d+-t)]], '/Terrain/')
	url = re.replace(url, [[/(?=f1c-\d+-d\.(\d+))]], '/Data/Layer_\\1/')
	url = re.replace(url, [[/(?=q2-\d+-q)]], '/Index/')
	local digits = re.find(url, [[/\w+-(\d+)-]], 1)
	if digits then
		url = re.replace(nil, nil, '/Zoom_' .. #digits .. '\\0')
	end
	hc.cache_file_name = hc.prepare_url(url)
	hc.monitor_string = '.GE'
end
